## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:           systemc
Version:        2.3.4
Release:        %autorelease
Summary:        SystemC Reference Implementation 
License:        Apache-2.0
URL:            https://systemc.org/overview/systemc
Source:         https://github.com/accellera-official/systemc/archive/refs/tags/%{version}.tar.gz
ExcludeArch:    s390x ppc64le

BuildRequires:  cmake
BuildRequires:  ninja-build
BuildRequires:  gcc-c++

# Workaround for some versions of systemc
# Patch0:       0001-Add-DEVELOPMENT.md.patch

# Specific to building Fedora
Patch1:         0002-Remove-RPATH.patch

%description
SystemC addresses the need for a system design and verification language 
that spans hardware and software. It is a language built as an ANSI C++ class 
library created for design and verification. Users worldwide are applying 
SystemC to system-level modeling, abstract analog/mixed-signal modeling,
architectural exploration, performance modeling, software development,
functional verification, and high-level synthesis. The SystemC API
and its semantics are developed by the Accellera Systems Initiative
and formally standardized and governed by the IEEE 
in the IEEE Std. 1666-2023 standard.


%package devel
Summary:        Development headers and libraries for %{name}
Requires:       %{name} = %{version}-%{release}

%description devel
%{base_description}

This package contains the development headers and libraries.

%prep
%autosetup -p1

%build
%cmake  \
    -G Ninja    \
    -D BUILD_SHARED_LIBS=ON \
    -D ENABLE_EXAMPLES=ON   \
    -D ENABLE_REGRESSION=ON \
    -D CMAKE_BUILD_TYPE=RelWithDebInfo  \
    -D CMAKE_INSTALL_PREFIX=%{_prefix}  \
    -D CMAKE_CXX_STANDARD=17    \
    -D CMAKE_INSTALL_FULL_LIBDIR=%{_libdir}
%cmake_build

%check
%cmake_build --target check

%install
# Remove extra debug file
rm -rf %{buildroot}/usr/lib/debug/%{_libdir}/libsystemc.so.*

%cmake_install

%files
%license LICENSE NOTICE src/sysc/packages/qt/copyright.h
%doc %{_datadir}/doc/systemc
%{_libdir}/libsystemc.so.*

%files devel
%{_includedir}/sysc
%{_includedir}/systemc*
%{_includedir}/tlm*
%{_libdir}/cmake/SystemC*
%{_libdir}/libsystemc.so

%changelog
## START: Generated by rpmautospec
* Sun Mar 24 2024 John Doe <packager@example.com> - 2.3.4-1
- Uncommitted changes
## END: Generated by rpmautospec
